题目链接:https://leetcode.com/problems/3sum/
题目:
Given an array S of n integers, are there elements a, b, c in S such that a + b + c = 0? Find all unique triplets in the array which gives the sum of zero.
Note:
Elements in a triplet (a,b,c) must be in non-descending order. (ie, a ≤ b ≤ c)
The solution set must not contain duplicate triplets.
For example, given array S = {-1 0 1 2 -1 -4},
A solution set is:
(-1, 0, 1)
(-1, -1, 2)
解题思路:
1. 由于最后的结果集不允许重复,先对数组进行排序能有效排除已计算过的重复的数。
2. 从后向前遍历数组,如果当前遍历的数不是数组的最后一个,就把它和其后继比较,看它们是否相等,如果相等就直接跳过本次循环,无需再计算重复的数。
3. 如果不相等,就把它的相反数作为另外两个数的和传递到另外一个函数中去。这时,问题就变为找出两个和为给定值的问题,即 2Sum 问题。
4. 由于题目中要求 a ≤ b ≤ c ,也就是我们现已知 -c 的值,要找 a 和 b,且 a 和 b 是非递减关系。我们的数组早已被排好序,只要从数组两边同时向中间遍历就有可能找到不只一组满足条件的 a 和 b。
5. 在遍历的过程中依然要注意比较当前值是否等于其前驱(对于从前往后遍历的 a)或者后继(对于从后往前遍历的 b),如果相等就跳过本次循环,避免找到重复的序列。
注意:
这题虽然与 2Sum 很类似,即 2Sum 是其子问题。但是不可用 HashMap 来解决,因为问题中不允许出现重复的序列,HashMap 不能很好地避免这个问题。
这题参考了别人的做法:http://blog.csdn.net/linhuanmars/article/details/19711651
public class Solution {
public List<List<Integer>> threeSum(int[] nums) {
List<List<Integer>> three = new ArrayList();
if(nums == null || nums.length < 3)
return three;
Arrays.sort(nums);
for(int i = nums.length - 1; i >= 0; i --) {
if(i < nums.length - 1 && nums[i] == nums[i + 1])
continue;
List<List<Integer>> two = twoSum(nums, i - 1, -nums[i]);
for(List<Integer> list : two) {
list.add(nums[i]);
}
three.addAll(two);
}
return three;
}
public List<List<Integer>> twoSum(int[] nums, int end, int target) {
List<List<Integer>> res = new ArrayList();
if(nums == null || nums.length < 2)
return res;
int l = 0;
int r = end;
while(l < r) {
if(nums[l] + nums[r] == target) {
List<Integer> list = new ArrayList();
list.add(nums[l]);
list.add(nums[r]);
res.add(list);
l ++;
r --;
while(l < r && nums[l] == nums[l - 1])
l ++;
while(l < r && nums[r] == nums[r + 1])
r --;
} else if(nums[l] + nums[r] > target) {
r --;
} else if(nums[l] + nums[r] < target) {
l ++;
}
}
return res;
}
}
311 / 311 test cases passed.
Status: Accepted
Runtime: 372 ms